/********************************  
* 
*    https://afdian.net/@Ironman
*
*
*********************************/


#ifndef __BMA_H
#define __BMA_H

#include "bma423.h"
#include <Arduino.h>
#include <Wire.h>
#include <math.h>

typedef struct Angle
{
    double X_Angle;
    double Y_Angle;
    double Z_Angle;
    
} Angle_t;

class BMA
{
public:
    BMA(TwoWire &bus);
    ~BMA();
    int8_t begin();
    int8_t config();
    int8_t getRawData();
    int8_t getStepCounter(uint32_t *step_out);
    int8_t getTemperatureC(int32_t *temp);
    int8_t getTemperatureF(int32_t *temp);
    int8_t getTemperatureK(int32_t *temp);
    int8_t getAngle(Angle_t *angle);

    void reset();

    struct bma4_accel sens_data;

private:
    static int8_t read(uint8_t reg_addr, uint8_t *reg_data, uint32_t length, void *intf_ptr);
    static int8_t write(uint8_t reg_addr, const uint8_t *reg_data, uint32_t length, void *intf_ptr);

    struct bma4_dev _dev;
    struct bma4_accel_config accel_conf;

    static TwoWire *_bus;
};

#endif
