#include "app_anim.h"

void obj_anim_in(lv_obj_t *obj, uint32_t time, uint32_t delay, lv_anim_ready_cb_t ready_cb, void *data)
{
        obj_anim_in_ver(obj, time, delay, ready_cb, data);
}

void obj_anim_out(lv_obj_t *obj, uint32_t time, uint32_t delay, lv_anim_ready_cb_t ready_cb, void *data)
{
        obj_anim_out_ver(obj, time, delay, ready_cb, data);
}

void obj_anim_in_ver(lv_obj_t *obj, uint32_t time, uint32_t delay, lv_anim_ready_cb_t ready_cb, void *data)
{
        if (obj != NULL)
        {
                lv_anim_t a;
                lv_anim_init(&a);
#if LV_USE_USER_DATA
                a.user_data = data;
#endif

                lv_anim_set_var(&a, obj);
                lv_anim_set_time(&a, time);
                lv_anim_set_delay(&a, delay);
                lv_anim_set_exec_cb(&a, (lv_anim_exec_xcb_t)lv_obj_set_y);
                lv_anim_set_ready_cb(&a, ready_cb);
                lv_anim_set_values(&a, lv_obj_get_y(obj) + LV_VER_RES, lv_obj_get_y(obj));
                lv_anim_start(&a);

                // lv_obj_fade_in(obj, LV_DEMO_PRINTER_ANIM_TIME - 50, delay);
                lv_obj_fade_in(obj, time, delay);
        }
}

void obj_anim_out_ver(lv_obj_t *obj, uint32_t time, uint32_t delay, lv_anim_ready_cb_t ready_cb, void *data)
{
        if (obj != NULL)
        {
                lv_anim_t a;
                lv_anim_init(&a);
#if LV_USE_USER_DATA
                a.user_data = data;
#endif

                lv_anim_set_var(&a, obj);
                lv_anim_set_time(&a, time);
                lv_anim_set_delay(&a, delay + 50);
                lv_anim_set_exec_cb(&a, (lv_anim_exec_xcb_t)lv_obj_set_y);
                lv_anim_set_ready_cb(&a, ready_cb);
                lv_anim_set_values(&a, lv_obj_get_y(obj), lv_obj_get_y(obj) + LV_VER_RES);
                lv_anim_start(&a);

                // lv_obj_fade_in(obj, LV_DEMO_PRINTER_ANIM_TIME - 50, delay);
                lv_obj_fade_out(obj, time, delay);
        }
}

void obj_anim_in_hor(lv_obj_t *obj, uint32_t time, uint32_t delay, lv_anim_ready_cb_t ready_cb, void *data)
{
        if (obj != NULL)
        {
                lv_anim_t a;
                lv_anim_init(&a);
#if LV_USE_USER_DATA
                a.user_data = data;
#endif

                lv_anim_set_var(&a, obj);
                lv_anim_set_time(&a, time);
                lv_anim_set_delay(&a, delay);
                lv_anim_set_exec_cb(&a, (lv_anim_exec_xcb_t)lv_obj_set_x);
                lv_anim_set_ready_cb(&a, ready_cb);
                lv_anim_set_values(&a, lv_obj_get_x(obj) + LV_HOR_RES, lv_obj_get_x(obj));
                lv_anim_start(&a);

                // lv_obj_fade_in(obj, LV_DEMO_PRINTER_ANIM_TIME - 50, delay);
                lv_obj_fade_in(obj, time, delay);
        }
}

void obj_anim_out_hor(lv_obj_t *obj, uint32_t time, uint32_t delay, lv_anim_ready_cb_t ready_cb, void *data)
{
        if (obj != NULL)
        {
                lv_anim_t a;
                lv_anim_init(&a);
#if LV_USE_USER_DATA
                a.user_data = data;
#endif

                lv_anim_set_var(&a, obj);
                lv_anim_set_time(&a, time);
                lv_anim_set_delay(&a, delay + 50);
                lv_anim_set_exec_cb(&a, (lv_anim_exec_xcb_t)lv_obj_set_x);
                lv_anim_set_ready_cb(&a, ready_cb);
                lv_anim_set_values(&a, lv_obj_get_x(obj), lv_obj_get_x(obj) + LV_HOR_RES);
                lv_anim_start(&a);

                // lv_obj_fade_in(obj, LV_DEMO_PRINTER_ANIM_TIME - 50, delay);
                lv_obj_fade_out(obj, time, delay);
        }
}