#include "app_backlight.h"
#include "board/board.h"
#include <Arduino.h>
const int maxValue = bit(15) - 1;
static uint8_t bl_level = 1;
void app_backlight_init()
{
    // Add LED RED to PWM0
    HwPWM0.addPin(PIN_TFT_BL);

    // Enable PWM modules with 15-bit resolutions(max) but different clock div
    HwPWM0.begin();
    HwPWM0.setResolution(15);
    HwPWM0.setClockDiv(PWM_PRESCALER_PRESCALER_DIV_8); // freq = 125Khz
    //   HwPWM0.writePin(PIN_TFT_BL, maxValue/10*bl_level, true);
}

void app_backlight_deinit()
{
    HwPWM0.stop();
    HwPWM0.removePin(PIN_TFT_BL);
}
void app_backlight_set_level(uint8_t level)
{
    if (level > 15)
    {
        level = 15;
    }
    HwPWM0.writePin(PIN_TFT_BL, maxValue / 15 * level, true);
    bl_level = level;
}
void app_backlight_on(void)
{
    HwPWM0.writePin(PIN_TFT_BL, maxValue / 15 * bl_level, true);
}
void app_backlight_off(void)
{
    HwPWM0.writePin(PIN_TFT_BL, 0, true);
    delay(30);
    HwPWM0.stop();
    digitalWrite(PIN_TFT_BL, 1);
    pinMode(PIN_TFT_BL, OUTPUT);
}

uint8_t app_backlight_get_level(void)
{
    return bl_level;
}
