#include "app_wdt.h"
#include <Arduino.h>

static SoftwareTimer wdtTimer;

// reload the watchdog timer that has been started by the bootloader and set for 10 seconds
static void wdt_feed()
{
  NRF_WDT->RR[0] = WDT_RR_RR_Reload;
}

static void wdt_init(uint8_t timeout)
{
  NRF_WDT->CRV = 32768 * timeout - 1; //S
  NRF_WDT->RREN |= 1 << 0;
  NRF_WDT->CONFIG |= WDT_CONFIG_HALT_Msk | WDT_CONFIG_SLEEP_Msk;
  NRF_WDT->RR[0] = WDT_RR_RR_Reload;
  NRF_WDT->TASKS_START = 1;
}

static void wdt_timer_callback(TimerHandle_t xTimerID)
{
  // freeRTOS timer ID, ignored if not used
  (void)xTimerID;
  wdt_feed();
}

void app_wdt_feed(void)
{
  wdt_feed();
}

bool app_wdt_init(void)
{
  wdt_init(8);

  // Configure the timer with 1000 ms interval, with our callback
  // wdtTimer.begin(2000, wdt_timer_callback);

  // // Start the timer
  // if(!wdtTimer.start())
  // {
  //   // tft.println("wdtTimer start fail");
  //   return false;
  // }

  return true;
}