#include "drv_st7735_lvgl.h"

//使用adafruit库
/* 颜色bug
You can try setting in _ST77xx.h:
#define ST77XX_MADCTL_RGB 0x08
and in _ST7735.cpp:

_colstart = 26;
_rowstart = 1;
Together with the tft.invertDisplay(true), this has fixed the issues I was having with the 0.96" 80x160(RGB)IPS from Aliexpress.


*/
// #include <lvgl.h>
// #include <Adafruit_GFX.h>    // Core graphics library
// #include <Adafruit_ST7735.h> // Hardware-specific library for ST7735
// #include <Adafruit_ST7789.h> // Hardware-specific library for ST7789
// #include <SPI.h>

//   #define TFT_CS         2
//   #define TFT_RST        3 // Or set to -1 and connect to Arduino RESET pin
//   #define TFT_DC         4
//   #define TFT_MOSI      7
//   #define TFT_MISO      -1
//   #define TFT_SCLK      5

// static SPIClass TFT_SPI(NRF_SPIM2, TFT_MISO, TFT_SCLK, TFT_MOSI);

// Adafruit_ST7735 tft = Adafruit_ST7735(&TFT_SPI, TFT_CS, TFT_DC, TFT_RST);

// static lv_disp_buf_t disp_buf;
// static lv_color_t buf[LV_HOR_RES_MAX * 10];

// static void my_disp_flush(lv_disp_drv_t *disp, const lv_area_t *area, lv_color_t *color_p);

// void lv_disp_st7735_init(void)
// {

//   TFT_SPI.begin();

//   tft.initR(INITR_MINI160x80);  // Init ST7735S mini display
//     tft.invertDisplay(true);
//   tft.setSPISpeed(8000000);
//   tft.setRotation(1);
//   tft.fillScreen(ST77XX_BLACK);

// delay(1000);tft.fillScreen(ST77XX_WHITE);
// delay(1000);tft.fillScreen(ST77XX_RED);
// delay(1000);tft.fillScreen(ST77XX_GREEN);
// delay(1000);tft.fillScreen(ST77XX_BLUE);
// delay(1000);tft.fillScreen(ST77XX_YELLOW);
//   lv_disp_buf_init(&disp_buf, buf, NULL, LV_HOR_RES_MAX * 10);

//     /*Initialize the display*/
//     lv_disp_drv_t disp_drv;
//     lv_disp_drv_init(&disp_drv);
//     disp_drv.hor_res = LV_HOR_RES_MAX;
//     disp_drv.ver_res = LV_VER_RES_MAX;
//     disp_drv.flush_cb = my_disp_flush;
//     disp_drv.buffer = &disp_buf;
//     lv_disp_drv_register(&disp_drv);

// }

// /* Display flushing */
// static void my_disp_flush(lv_disp_drv_t *disp, const lv_area_t *area, lv_color_t *color_p)
// {
//     uint32_t w = (area->x2 - area->x1 + 1);
//     uint32_t h = (area->y2 - area->y1 + 1);

//     tft.startWrite();
//     // tft.setAddrWindow(area->x1, area->y1, w, h)
//     tft.drawRGBBitmap(area->x1, area->y1,&color_p->full, w ,h);
//     tft.endWrite();

//     lv_disp_flush_ready(disp);
// }

//使用tft_espi库
#include <SPI.h>
#include <lvgl.h>
#include <TFT_eSPI.h>
TFT_eSPI tft = TFT_eSPI(); /* TFT instance */
static lv_disp_buf_t disp_buf;
static lv_color_t buf[LV_HOR_RES_MAX * 10];

static void my_disp_flush(lv_disp_drv_t *disp, const lv_area_t *area, lv_color_t *color_p);
void lv_disp_st7735_init(bool init)
{

  if (init)
  {
    tft.begin();        /* TFT init */
    tft.setRotation(1); /* Landscape orientation */
    tft.fillScreen(TFT_BLACK);
  }
  else
  {
    tft.init_noboot();
    tft.setRotation(1); /* Landscape orientation */
  }

  lv_disp_buf_init(&disp_buf, buf, NULL, LV_HOR_RES_MAX * 10);

  /*Initialize the display*/
  lv_disp_drv_t disp_drv;
  lv_disp_drv_init(&disp_drv);
  disp_drv.hor_res = LV_HOR_RES_MAX;
  disp_drv.ver_res = LV_VER_RES_MAX;
  disp_drv.flush_cb = my_disp_flush;
  disp_drv.buffer = &disp_buf;
  lv_disp_drv_register(&disp_drv);
}

/* Display flushing */
static void my_disp_flush(lv_disp_drv_t *disp, const lv_area_t *area, lv_color_t *color_p)
{
  // if(area->x2 < 0) return;
  // if(area->y2 < 0) return;
  // if(area->x1 > LV_HOR_RES_MAX - 1) return;
  // if(area->y1 > LV_VER_RES_MAX - 1) return;

  // /*Truncate the area to the screen*/
  // int32_t act_x1 = area->x1 < 0 ? 0 : area->x1;
  // int32_t act_y1 = area->y1 < 0 ? 0 : area->y1;
  // int32_t act_x2 = area->x2 > LV_HOR_RES_MAX - 1 ? LV_HOR_RES_MAX - 1 : area->x2;
  // int32_t act_y2 = area->y2 > LV_VER_RES_MAX - 1 ? LV_VER_RES_MAX - 1 : area->y2;

  // uint32_t w = (act_x2 - act_x1 + 1);
  // uint32_t h = (act_y2 - act_y1 + 1);

  uint32_t w = (area->x2 - area->x1 + 1);
  uint32_t h = (area->y2 - area->y1 + 1);

  tft.startWrite();
  tft.setAddrWindow(area->x1, area->y1, w, h);
  tft.pushColors(&color_p->full, w * h, true);
  tft.endWrite();

  lv_disp_flush_ready(disp);
}