#include "page/page_clock.h"
#include "page/page_motion.h"
#include "page/page_manager.h"
// #include "page/page_calendar.h"
#include "page/page_env.h"
#include "page/page_game.h"
#include "page/page_sys.h"
#include "page/page_backlight.h"
#include "page/page_about.h"
#include "page/sys/sys_select.h"
#include "page/sys/page_time_set.h"
#include "page/sys/page_date_set.h"
#include "page/sys/page_mouse.h"
#include "page/sys/page_flashlight.h"
#include "page/page_motion_week.h"

#include "page/game/game_select.h"

#include "page/game/flappybird/flappybird.h"

#include "driver/drv_st7735_lvgl.h"

page_t page_god; // 总页面
page_t page_motion;
page_t page_motion_week;

page_t page_clock;
page_t page_env;
page_t page_calendar;
page_t page_sys;
page_t page_game;
page_t page_game_select;
page_t page_backlight;
page_t page_about;
page_t page_mouse;
page_t page_flashlight;
page_t page_sys_select;
page_t page_time_set;
page_t page_date_set;
page_t page_flappybird;

void page_create(void)
{
  page_item_reset(&page_god);
  page_item_reset(&page_motion);
  // page_item_reset(&page_motion_week);
  page_item_reset(&page_clock);
  page_item_reset(&page_env);
  // page_item_reset(&page_calendar);
  page_item_reset(&page_sys);
  page_item_reset(&page_game);
  page_item_reset(&page_backlight);
  page_item_reset(&page_about);
  page_item_reset(&page_mouse);
  page_item_reset(&page_flashlight);
  page_item_reset(&page_time_set);
  page_item_reset(&page_date_set);
  page_item_reset(&page_flappybird);

  page_item_set_cb(&page_clock, (enter_cb_t)page_clock_enter, (loop_cb_t)page_clock_loop, (exit_cb_t)page_clock_exit);
  page_item_set_cb(&page_motion, (enter_cb_t)page_motion_enter, (loop_cb_t)page_motion_loop, (exit_cb_t)page_motion_exit);
  //  page_item_set_cb(&page_motion_week, (enter_cb_t)page_motion_week_enter, (loop_cb_t)page_motion_week_loop, (exit_cb_t)page_motion_week_exit);
  page_item_set_cb(&page_env, (enter_cb_t)page_env_enter, (loop_cb_t)page_env_loop, (exit_cb_t)page_env_exit);
  // page_item_set_cb(&page_calendar, (enter_cb_t)page_calendar_enter, (loop_cb_t)page_calendar_loop, (exit_cb_t)page_calendar_exit);
  page_item_set_cb(&page_sys, (enter_cb_t)page_sys_enter, (loop_cb_t)page_sys_loop, (exit_cb_t)page_sys_exit);
  page_item_set_cb(&page_game, (enter_cb_t)page_game_enter, (loop_cb_t)page_game_loop, (exit_cb_t)page_game_exit);
  page_item_set_cb(&page_game_select, (enter_cb_t)game_select_enter, (loop_cb_t)game_select_loop, (exit_cb_t)game_select_exit);
  page_item_set_cb(&page_backlight, (enter_cb_t)page_backlight_enter, (loop_cb_t)page_backlight_loop, (exit_cb_t)page_backlight_exit);
  page_item_set_cb(&page_about, (enter_cb_t)page_about_enter, (loop_cb_t)page_about_loop, (exit_cb_t)page_about_exit);
  page_item_set_cb(&page_mouse, (enter_cb_t)page_mouse_enter, (loop_cb_t)page_mouse_loop, (exit_cb_t)page_mouse_exit);
  page_item_set_cb(&page_flashlight, (enter_cb_t)page_flashlight_enter, (loop_cb_t)page_flashlight_loop, (exit_cb_t)page_flashlight_exit);
  page_item_set_cb(&page_sys_select, (enter_cb_t)sys_select_enter, (loop_cb_t)sys_select_loop, (exit_cb_t)sys_select_exit);
  page_item_set_cb(&page_time_set, (enter_cb_t)page_time_set_enter, (loop_cb_t)page_time_set_loop, (exit_cb_t)page_time_set_exit);
  page_item_set_cb(&page_date_set, (enter_cb_t)page_date_set_enter, (loop_cb_t)page_date_set_loop, (exit_cb_t)page_date_set_exit);
  page_item_set_cb(&page_flappybird, (enter_cb_t)flappybird_enter, (loop_cb_t)flappybird_loop, (exit_cb_t)flappybird_exit);

  page_item_add_child(&page_god, &page_clock, false);
  page_item_add_child(&page_god, &page_motion, false);
  page_item_add_child(&page_god, &page_env, true);
  // page_item_add_child(&page_god,  &page_game,    false);
  // page_item_add_child(&page_god,  &page_sys,     true);

  // // page_item_add_child(&page_clock,  &page_calendar,     false);
  // page_item_add_child(&page_game,   &page_game_select,  false);
  // page_item_add_child(&page_sys,    &page_sys_select,   false);

  //  page_item_add_child(&page_sys_select,    &page_backlight,   false);
  //  page_item_add_child(&page_sys_select,    &page_about,   false);
  //  page_item_add_child(&page_sys_select,    &page_time_set,   false);
  //  page_item_add_child(&page_sys_select,    &page_date_set,   false);
  //  page_item_add_child(&page_sys_select,    &page_mouse,   false);
  //  page_item_add_child(&page_sys_select,    &page_flashlight,   false);
  //  page_item_add_child(&page_game_select,    &page_flappybird,   false);

  // page_item_add_child(&page_motion, &page_motion_week ,false);

  manager.cur = &page_clock;
  manager.old = NULL;
  manager.busy = false;

  if (manager_init() == false)
  {
    tft.setCursor(0, 0);
    tft.setTextColor(TFT_RED);
    tft.println("manager init fail");
    delay(1000);
  }
  else
  {
    manager.cur->enter(NULL);
    // tft.println("manager init success");
    if (manager_loop_start())
    {

      // tft.println("manager loop start init success");
    }
    else
    {
      tft.setCursor(0, 0);
      tft.setTextColor(TFT_RED);
      tft.println("manager loop start init fail");
      delay(1000);
    }
  }
}