#include "page_game.h"
#include "page/page_manager.h"

#include "app/app_anim.h"
#include "app/app_key.h"

static lv_obj_t *scr;
static lv_obj_t *roller;
static void anim_in_ready_cb(lv_anim_t *a)
{
  app_key_clean();
  manager_set_busy_state(false);
}

static void anim_out_ready_cb(lv_anim_t *a)
{
  lv_obj_del(scr);
}

lv_obj_t *page_game_enter(void *data)
{
  scr = lv_obj_create(lv_scr_act(), NULL);
  lv_obj_clean_style_list(scr, LV_OBJ_PART_MAIN);
  lv_obj_set_style_local_bg_opa(scr, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_OPA_COVER);
  lv_obj_set_style_local_bg_color(scr, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_BLACK);
  lv_obj_set_style_local_border_color(scr, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_BLACK);
  lv_obj_set_style_local_radius(scr, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, 0);
  lv_obj_set_size(scr, LV_HOR_RES, LV_VER_RES);
  lv_obj_set_pos(scr, 0, 0);

  // LV_IMG_DECLARE(img_game);
  // lv_obj_t *img = lv_img_create(scr,NULL);
  // lv_img_set_src(img,LV_SYMBOL_LIST "");

  lv_obj_t *title = lv_label_create(scr, NULL);
  lv_label_set_text(title, LV_SYMBOL_LIST "    GAME");

  // lv_obj_align(img,NULL,LV_ALIGN_IN_LEFT_MID,30,0);
  lv_obj_align(title, NULL, LV_ALIGN_IN_RIGHT_MID, -20, 0);

  // lv_mem_monitor_t info;
  // lv_mem_monitor(&info);
  // lv_obj_t *mem = lv_label_create(scr,NULL);
  // lv_obj_set_style_local_text_font(mem,LV_OBJ_PART_MAIN,LV_STATE_DEFAULT,&lv_font_unscii_8);
  // lv_obj_set_style_local_text_color(mem,LV_OBJ_PART_MAIN,LV_STATE_DEFAULT,LV_COLOR_RED);
  // lv_label_set_text_fmt(mem,"%d",info.free_size);
  // lv_obj_align(mem,NULL,LV_ALIGN_IN_BOTTOM_RIGHT,0,0);

  //进入动画，进行切换
  obj_anim_in(scr, 100, 100, anim_in_ready_cb, NULL);
  return scr;
}

static void page_game_item_enter(void *data);

//根据按键情况，对其进行不同操作处理
void page_game_loop(void *data)
{
  KEY_TYPE key = app_key_get();
  switch (key)
  {
  case KEY0_SHORT:
    manager_switch(LEVEL_PREV);

    break;
  case KEY1_SHORT:
    manager_switch(LEVEL_NEXT);
    break;
  case KEY0_LONG:
    //  manager_switch(LEVEL_PARENT);
    break;
  case KEY1_LONG:
    manager_switch(LEVEL_CHILD);
    break;

  default:
    break;
  }
}

void page_game_exit(void *data)
{

  // lv_task_del(task);
  //退出动画，进行切换
  obj_anim_out(scr, 100, 0, anim_out_ready_cb, NULL);
}
