#include "page_motion_week.h"

#include <Arduino.h>

#include "board/board.h"
#include "app/app_key.h"
#include "app/app_anim.h"
#include "page/page_manager.h"
static lv_obj_t *scr;

static void anim_in_ready_cb(lv_anim_t *a)
{
    app_key_clean();
    manager_set_busy_state(false);
}

static void anim_out_ready_cb(lv_anim_t *a)
{
    lv_obj_del(scr);
}

lv_obj_t *page_motion_week_enter(void *data)
{

    scr = lv_obj_create(lv_scr_act(), NULL);
    lv_obj_clean_style_list(scr, LV_OBJ_PART_MAIN);
    lv_obj_set_style_local_bg_opa(scr, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_OPA_COVER);
    lv_obj_set_style_local_bg_color(scr, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_BLACK);
    lv_obj_set_style_local_border_color(scr, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_BLACK);
    lv_obj_set_style_local_radius(scr, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, 0);
    lv_obj_set_size(scr, LV_HOR_RES, LV_VER_RES);
    lv_obj_set_pos(scr, 0, 0);

    // lv_obj_t *chart = lv_chart_create(scr, NULL);
    // lv_obj_set_size(chart, LV_HOR_RES, LV_VER_RES);
    // lv_obj_align(chart, NULL, LV_ALIGN_CENTER, 0, 0);
    // lv_chart_set_type(chart, LV_CHART_TYPE_COLUMN); /*Show lines and points too*/
    // lv_chart_set_point_count(chart,7);
    // lv_chart_set_div_line_count(chart,0,0);

    // lv_obj_set_style_local_border_opa(chart,LV_CHART_PART_BG,LV_STATE_DEFAULT,LV_OPA_TRANSP);
    // lv_obj_set_style_local_bg_color(chart,LV_CHART_PART_BG,LV_STATE_DEFAULT,LV_COLOR_BLACK);
    // lv_obj_set_style_local_bg_opa(chart,LV_CHART_PART_BG,LV_STATE_DEFAULT,LV_OPA_TRANSP);

    // /*Add a faded are effect*/
    // lv_obj_set_style_local_bg_opa(chart, LV_CHART_PART_SERIES, LV_STATE_DEFAULT, LV_OPA_50); /*Max. opa.*/
    // lv_obj_set_style_local_bg_grad_dir(chart, LV_CHART_PART_SERIES, LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
    // lv_obj_set_style_local_bg_main_stop(chart, LV_CHART_PART_SERIES, LV_STATE_DEFAULT, 255); /*Max opa on the top*/
    // lv_obj_set_style_local_bg_grad_stop(chart, LV_CHART_PART_SERIES, LV_STATE_DEFAULT, 0);   /*Transparent on the bottom*/
    // /*Add two data series*/
    // lv_chart_series_t *ser1 = lv_chart_add_series(chart, LV_COLOR_GREEN);

    // /*Set the next points on 'ser1'*/
    // lv_chart_set_next(chart, ser1, 31);
    // lv_chart_set_next(chart, ser1, 66);
    // lv_chart_set_next(chart, ser1, 10);
    // lv_chart_set_next(chart, ser1, 89);
    // lv_chart_set_next(chart, ser1, 63);
    // lv_chart_set_next(chart, ser1, 56);
    // lv_chart_set_next(chart, ser1, 32);

    // lv_chart_refresh(chart);

    lv_obj_t *label[7];
    lv_obj_t *bar[7];

    // randomSeed()

    for (uint8_t i = 0; i < 7; i++)
    {
        long x = random(30000);
        label[i] = lv_label_create(scr, NULL);
        lv_label_set_text_fmt(label[i], "%05d", x);
        // lv_obj_set_style_local_text_color(label[i],LV_LABEL_PART_MAIN,LV_STATE_DEFAULT,LV_COLOR_BLUE);
        lv_obj_set_style_local_text_font(label[i], LV_LABEL_PART_MAIN, LV_STATE_DEFAULT, &lv_font_unscii_8);
        lv_obj_align(label[i], scr, LV_ALIGN_IN_TOP_LEFT, 0, i * 11);

        bar[i] = lv_bar_create(scr, NULL);
        lv_obj_set_size(bar[i], LV_HOR_RES - 60, 5);
        lv_obj_align(bar[i], label[i], LV_ALIGN_OUT_RIGHT_MID, 5, 0);
        lv_bar_set_anim_time(bar[i], 500);
        lv_bar_set_range(bar[i], 0, 30000);
        lv_bar_set_value(bar[i], x, LV_ANIM_ON);
        lv_obj_set_style_local_bg_color(bar[i], LV_BAR_PART_BG, LV_STATE_DEFAULT, LV_COLOR_GRAY);
    }

    // static lv_color_t needle_colors[3];
    // needle_colors[0] = LV_COLOR_BLUE;

    // /*Create a gauge*/
    // lv_obj_t * gauge1 = lv_gauge_create(scr, NULL);
    // lv_gauge_set_needle_count(gauge1, 1, needle_colors);
    // lv_obj_set_size(gauge1, 80, 80);
    // lv_obj_align(gauge1, NULL, LV_ALIGN_IN_LEFT_MID, 0, 0);
    // /*Set the values*/
    // lv_gauge_set_value(gauge1, 0, 10);

    // /*Create a gauge*/
    // lv_obj_t * gauge2 = lv_gauge_create(scr, NULL);
    // lv_gauge_set_needle_count(gauge2, 1, needle_colors);
    // lv_obj_set_size(gauge2, 80, 80);
    // lv_obj_align(gauge2, NULL, LV_ALIGN_IN_RIGHT_MID, 0, 0);
    // /*Set the values*/
    // lv_gauge_set_value(gauge2, 0, 10);

    // lv_mem_monitor_t info;
    // lv_mem_monitor(&info);
    // lv_obj_t *mem = lv_label_create(scr, NULL);
    // lv_obj_set_style_local_text_font(mem, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, &lv_font_unscii_8);
    // lv_obj_set_style_local_text_color(mem, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_RED);
    // lv_label_set_text_fmt(mem, "%d", info.free_size);
    // lv_obj_align(mem, NULL, LV_ALIGN_IN_BOTTOM_RIGHT, 0, 0);

    //进入动画，进行切换
    obj_anim_in(scr, 100, 100, anim_in_ready_cb, NULL);
    return scr;
}

//根据按键情况，对其进行不同操作处理
void page_motion_week_loop(void *data)
{
    KEY_TYPE key = app_key_get();

    switch (key)
    {
    case KEY0_SHORT:
        //   manager_switch(LEVEL_PREV);
        break;
    case KEY1_SHORT:
        //   manager_switch(LEVEL_NEXT);

        break;
    case KEY0_LONG:
        manager_switch(LEVEL_PARENT);
        break;
    case KEY1_LONG:
        // manager_switch(LEVEL_CHILD);
        break;

    default:
        break;
    }
}

void page_motion_week_exit(void *data)
{

    // lv_task_del(task);
    //退出动画，进行切换
    obj_anim_out(scr, 100, 0, anim_out_ready_cb, NULL);
}
