#include "page_date_set.h"

#include <Arduino.h>

#include "board/board.h"
#include "app/app_key.h"
#include "app/app_anim.h"
#include "page/page_manager.h"
static lv_obj_t *scr;
static lv_obj_t *roller[3];
static uint8_t item = 0;

static void anim_in_ready_cb(lv_anim_t *a)
{
    app_key_clean();
    manager_set_busy_state(false);
}

static void anim_out_ready_cb(lv_anim_t *a)
{
    lv_obj_del(scr);
}

lv_obj_t *page_date_set_enter(void *data)
{

    scr = lv_obj_create(lv_scr_act(), NULL);
    lv_obj_clean_style_list(scr, LV_OBJ_PART_MAIN);
    lv_obj_set_style_local_bg_opa(scr, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_OPA_COVER);
    lv_obj_set_style_local_bg_color(scr, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_BLACK);
    lv_obj_set_style_local_border_color(scr, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_BLACK);
    lv_obj_set_style_local_radius(scr, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, 0);
    lv_obj_set_size(scr, LV_HOR_RES, LV_VER_RES);
    lv_obj_set_pos(scr, 0, 0);

    roller[1] = lv_roller_create(scr, NULL);
    lv_obj_set_style_local_text_font(roller[1], LV_ROLLER_PART_BG, LV_STATE_DEFAULT, &lv_font_unscii_8);
    lv_obj_set_style_local_text_font(roller[1], LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, &lv_font_unscii_8);
    lv_obj_set_style_local_bg_color(roller[1], LV_ROLLER_PART_SELECTED, LV_STATE_DISABLED, LV_COLOR_GRAY);
    lv_roller_set_options(roller[1],
                          "01\n"
                          "02\n"
                          "03\n"
                          "04\n"
                          "05\n"
                          "06\n"
                          "07\n"
                          "08\n"
                          "09\n"
                          "10\n"
                          "11\n"
                          "12",
                          LV_ROLLER_MODE_INIFINITE);

    lv_roller_set_visible_row_count(roller[1], 3);
    lv_roller_set_auto_fit(roller[1], true);
    lv_roller_set_selected(roller[1], 6, LV_ANIM_OFF);

    // lv_obj_set_event_cb(roller[1], event_handler);

    roller[0] = lv_roller_create(scr, NULL);
    lv_obj_set_style_local_text_font(roller[0], LV_ROLLER_PART_BG, LV_STATE_DEFAULT, &lv_font_unscii_8);
    lv_obj_set_style_local_text_font(roller[0], LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, &lv_font_unscii_8);
    lv_obj_set_style_local_bg_color(roller[0], LV_ROLLER_PART_SELECTED, LV_STATE_DISABLED, LV_COLOR_GRAY);
    lv_roller_set_options(roller[0],
                          "2019\n"
                          "2020\n"
                          "2021\n"
                          "2022\n"
                          "2023\n"
                          "2024\n"
                          "2025\n"
                          "2026\n"
                          "2027\n"
                          "2028\n"
                          "2029\n"
                          "2030\n"
                          "2031",
                          LV_ROLLER_MODE_INIFINITE);

    lv_roller_set_visible_row_count(roller[0], 3);
    lv_roller_set_auto_fit(roller[0], true);
    lv_roller_set_selected(roller[0], 1, LV_ANIM_OFF);

    roller[2] = lv_roller_create(scr, NULL);
    lv_obj_set_style_local_text_font(roller[2], LV_ROLLER_PART_BG, LV_STATE_DEFAULT, &lv_font_unscii_8);
    lv_obj_set_style_local_text_font(roller[2], LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, &lv_font_unscii_8);
    lv_obj_set_style_local_bg_color(roller[2], LV_ROLLER_PART_SELECTED, LV_STATE_DISABLED, LV_COLOR_GRAY);
    lv_roller_set_options(roller[2],
                          "01\n"
                          "02\n"
                          "03\n"
                          "04\n"
                          "05\n"
                          "06\n"
                          "07\n"
                          "08\n"
                          "09\n"
                          "10\n"
                          "11\n"
                          "12\n"
                          "13\n"
                          "14\n"
                          "15\n"
                          "16\n"
                          "17\n"
                          "18\n"
                          "19\n"
                          "20\n"
                          "21\n"
                          "22\n"
                          "23\n"
                          "24\n"
                          "25\n"
                          "26\n"
                          "27\n"
                          "28\n"
                          "29\n"
                          "30\n"
                          "31",
                          LV_ROLLER_MODE_INIFINITE);
    lv_roller_set_visible_row_count(roller[2], 3);
    lv_roller_set_auto_fit(roller[2], true);
    lv_roller_set_selected(roller[2], 27, LV_ANIM_OFF);

    lv_obj_set_style_local_bg_color(roller[0], LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, LV_COLOR_GREEN);
    lv_obj_set_style_local_bg_color(roller[1], LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, LV_COLOR_GRAY);
    lv_obj_set_style_local_bg_color(roller[2], LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, LV_COLOR_GRAY);

    lv_obj_align(roller[0], NULL, LV_ALIGN_IN_LEFT_MID, 0, 0);
    lv_obj_align(roller[1], roller[0], LV_ALIGN_OUT_RIGHT_MID, 3, 0);
    lv_obj_align(roller[2], roller[1], LV_ALIGN_OUT_RIGHT_MID, 3, 0);

    // lv_mem_monitor_t info;
    // lv_mem_monitor(&info);
    // lv_obj_t *mem = lv_label_create(scr, NULL);
    // lv_obj_set_style_local_text_font(mem, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, &lv_font_unscii_8);
    // lv_obj_set_style_local_text_color(mem, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_RED);
    // lv_label_set_text_fmt(mem, "%d", info.free_size);
    // lv_obj_align(mem, scr, LV_ALIGN_IN_BOTTOM_RIGHT, 0, 0);

    //进入动画，进行切换
    obj_anim_in(scr, 100, 100, anim_in_ready_cb, NULL);
    return scr;
}

//根据按键情况，对其进行不同操作处理
void page_date_set_loop(void *data)
{
    KEY_TYPE key = app_key_get();
    uint16_t id = lv_roller_get_selected(roller[item]);
    uint16_t cnt = lv_roller_get_option_cnt(roller[item]);

    switch (key)
    {
    case KEY0_SHORT:
        id--;
        if (id == 0)
        {
            id = cnt - 1;
        }
        lv_roller_set_selected(roller[item], id, LV_ANIM_OFF);
        //   manager_switch(LEVEL_PREV);
        break;
    case KEY1_SHORT:
        //   manager_switch(LEVEL_NEXT);
        id++;
        if (id == cnt)
        {
            id = 0;
        }
        lv_roller_set_selected(roller[item], id, LV_ANIM_OFF);

        break;
    case KEY0_LONG:
        manager_switch(LEVEL_PARENT);
        break;
    case KEY1_LONG:
        // manager_switch(LEVEL_CHILD);
        item++;
        if (item == 3)
        {
            item = 0;
        }
        for (uint8_t i = 0; i < 3; i++)
        {
            if (i == item)
            {
                lv_obj_set_style_local_bg_color(roller[item], LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, LV_COLOR_GREEN);
            }
            else
            {
                lv_obj_set_style_local_bg_color(roller[i], LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, LV_COLOR_GRAY);
            }
        }
        break;

    default:
        break;
    }
}

void page_date_set_exit(void *data)
{

    // lv_task_del(task);
    //退出动画，进行切换
    obj_anim_out(scr, 100, 0, anim_out_ready_cb, NULL);
}
