#include "page_flashlight.h"
#include "page/page_manager.h"

#include "app/app_anim.h"
#include "app/app_key.h"
#include "app/app_backlight.h"

static lv_obj_t *scr;
static uint8_t level;
// static lv_obj_t *label;
// static lv_task_t *task;
// void task_motion(struct _lv_task_t *);

static void anim_in_ready_cb(lv_anim_t *a)
{
  app_key_clean();
  manager_set_busy_state(false);
  level = app_backlight_get_level();
  app_backlight_set_level(15);
}

static void anim_out_ready_cb(lv_anim_t *a)
{
  lv_obj_del(scr);
}

lv_obj_t *page_flashlight_enter(void *data)
{

  scr = lv_obj_create(lv_scr_act(), NULL);
  lv_obj_clean_style_list(scr, LV_OBJ_PART_MAIN);
  lv_obj_set_style_local_bg_opa(scr, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_OPA_COVER);
  lv_obj_set_style_local_bg_color(scr, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);
  lv_obj_set_style_local_border_color(scr, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);
  lv_obj_set_style_local_radius(scr, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, 0);
  lv_obj_set_size(scr, LV_HOR_RES, LV_VER_RES);
  lv_obj_set_pos(scr, 0, 0);

  //进入动画，进行切换
  obj_anim_in(scr, 100, 100, anim_in_ready_cb, NULL);

  return scr;
}

//根据按键情况，对其进行不同操作处理
void page_flashlight_loop(void *data)
{

  KEY_TYPE key = app_key_get();
  switch (key)
  {
  case KEY0_SHORT:
    // manager_switch(LEVEL_PREV);

    break;
  case KEY1_SHORT:
    // manager_switch(LEVEL_NEXT);

    break;
  case KEY0_LONG:
    manager_switch(LEVEL_PARENT);

    break;
  case KEY1_LONG:
    // manager_switch(LEVEL_CHILD);

    break;

  default:
    break;
  }
}

void page_flashlight_exit(void *data)
{

  //   lv_task_del(task);
  //退出动画，进行切换
  obj_anim_out(scr, 100, 0, anim_out_ready_cb, NULL);
  app_backlight_set_level(level);
}
